<?php
ini_set("display_errors",1);
error_reporting(E_ALL);
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2016 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class PMBrealex
{
  var $parser;
  function checkMethod($params)
  {
    $vendor_missing=JText::_( 'PMB_REALEX_MODULE_ERR_VENDOR' );
    $password_missing=JText::_( 'PMB_REALEX_MODULE_ERR_PASS' );
    $password2_missing=JText::_( 'PMB_REALEX_MODULE_ERR_PASS2' );
    $vendor_name=trim($params->get('realex_user'));
    $vendor_password=trim($params->get('realex_password'));
    $vendor_password2=trim($params->get('realex_password2'));
    if($vendor_name=='')
    {
      ?>
        <div class="pmb_error"><?php echo $vendor_missing;?></div>
      <?php
      return false;
    }
    else if($vendor_password=='')
    {
      ?>
        <div class="pmb_error"><?php echo $password_missing;?></div>
      <?php
      return false;
    }
    /*
    else if($vendor_password2=='')
    {
      ? >
        <div class="pmb_error"><?php echo $password2_missing;? ></div>
      < ?php
      return false;
    }
    */
    return true;
  }
  function getPMBDomain()
  {
    $domain=str_ireplace("www.","",$_SERVER['HTTP_HOST']);
    $is_ip = ip2long($domain) !== false;
    if($is_ip)
    {
      return false;
    }
    else if(trim($domain)=='')
    {
      return false;
    }
    
    return $domain;
  }
  function doPayment($params,$details,$all_params)
  {
    
    $dchk=$all_params['dchk'];
    $lic=$all_params['pmblic'];
    $the_domain=$this->getPMBDomain();
    if($the_domain)
    {
      $chk=md5($lic.$the_domain);
      if($dchk!=$chk)
      {
        echo '<font color="red"><strong>'.JText::_( 'PMB_MODULE_LICENSE_ERR' ).'</strong></font>';
        exit;
      }
    }

    $product_name=$params->get('product_name');
    $invoice_field=$params->get('show_inv_field');
    $cost_per_transaction=$params->get('realex_trans_cost')+0;
    $percent_per_transaction=$params->get('realex_trans_percent_cost')+0;
    
    $vendor_name=trim($params->get('realex_user'));
    $vendor_password=trim($params->get('realex_password'));
    $vendor_password2=trim($params->get('realex_password2'));
    $language=$params->get('realex_language');
    $mode=$params->get('realex_mode');
    $currency=$params->get('realex_currency');
    
    $details['subtotal']=$details['payment'];
    $payment=$details['payment'];
    if($cost_per_transaction>0)
    {
      $payment+=$cost_per_transaction;
    }
    if($percent_per_transaction>0)
    {
      $payment=$payment+($payment*$percent_per_transaction);
    }
    
    $payment=round($payment,2);
    $payment=number_format($payment,2);
    $details['payment']=$payment;
    $details['mode']=$mode;
    $details['currency']=$currency;
    
    $cc_number=isset($_POST['cc_number'])?$_POST['cc_number']:"";
    $cc_name=isset($_POST['cc_name'])?$_POST['cc_name']:"";
    $cc_expiry=isset($_POST['cc_expiry'])?$_POST['cc_expiry']:"";
    $cc_cvc=isset($_POST['cc_cvc'])?$_POST['cc_cvc']:"";
    $cc_card_type=isset($_POST['cc_card_type'])?$_POST['cc_card_type']:"";
    
    $cc_number=trim(str_replace(" ","",$cc_number));
    $cc_name=trim($cc_name);
    $cc_expiry=trim(str_replace(" / ","",$cc_expiry));
    $cc_cvc=trim(str_replace(" / ","",$cc_cvc));
    $cc_card_type=trim($cc_card_type);
    
    $cc_types=array(
    'amex'=>'AMEX',
    'dankort'=>'dankort',
    'dinersclub'=>'DINERS',
    'discover'=>'discover',
    'jcb'=>'JCB',
    'laser'=>'LASER',
    'maestro'=>'maestro',
    'mastercard'=>'MC',
    'unionpay'=>'unionpay',
    'visaelectron'=>'VISA',
    'elo'=>'elo',
    'visa'=>'VISA'
    );
    $cc_card_type=$cc_types[$cc_card_type];

    if($params->get('mail_pending')!=0)
    {
      require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
      $pmbf=new PMBFunctions();
      $pmbf->sendConfirmationMail("pending",$all_params,$details,'Realex');//send pending mail
    }
    $pmbf->saveOrder($payment,$mode,$all_params,$details,'Realex');
    
    $languageCode=strtolower($language);
    if($languageCode!='en' && $languageCode!='pl')
    {
      $languageCode='en';
    }
    $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' order.';
    
    if($invoice_field)
    {
      $PaymentDescription=$product_name.' at '.$_SERVER['HTTP_HOST'].' for '.$details['InvNr'];
    }
    
    $amount=round($payment,2)*100;
    
    // In this example the values are hardcoded in.In reality they should be read in by a script or from a database.
    $cardnumber = $cc_number;
    $cardname = $cc_name;
    $cardtype = $cc_card_type;
    $expdate = $cc_expiry;
    
    // These values will be provided to you by realex Payments, if you have not already received them please contact us
    $merchantid = $vendor_name;
    $secret = $vendor_password;
    $account = $vendor_password2;
    
    //Creates timestamp that is needed to make up orderid
    $timestamp = strftime("%Y%m%d%H%M%S");

    //You can use any alphanumeric combination for the orderid.Although each transaction must have a unique orderid.
    $orderid = $details['order_id'];
    
    
    // This section of code creates the md5hash that is needed
    $tmp = "$timestamp.$merchantid.$orderid.$amount.$currency.$cardnumber";
    $md5hash = md5($tmp);
    $tmp = "$md5hash.$secret";
    $md5hash = md5($tmp);
    
    //A number of variables are needed to generate the request xml that is send to Realex Payments.
    $xml = "<request type='auth' timestamp='$timestamp'>
    	<merchantid>$merchantid</merchantid>
    	<account>$account</account>
    	<orderid>$orderid</orderid>
    	<amount currency='$currency'>$amount</amount>
    	<card> 
    		<number>$cardnumber</number>
    		<expdate>$expdate</expdate>
    		<type>$cardtype</type> 
    		<chname>$cardname</chname> 
    	</card> 
    	<autosettle flag='1'/>
    	<md5hash>$md5hash</md5hash>
      <comments>
        <comment id=\"1\">".$PaymentDescription."</comment>
      </comments>
    	<tssinfo>
    		<address type=\"billing\">
          <code>".$details['BillZip']."</code>
    			<country>".$details['BillCountry']."</country>
    		</address>
    	</tssinfo>
    </request>";
    
    // Send the request array to Realex Payments
    $ch = curl_init();    
    curl_setopt($ch, CURLOPT_URL, "https://epage.payandshop.com/epage-remote.cgi");
    curl_setopt($ch, CURLOPT_POST, 1); 
    curl_setopt($ch, CURLOPT_USERAGENT, "payandshop.com php version 0.9"); 
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); 
    curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
    
    if($mode=="TEST")
    {
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); //This should always be set to 'TRUE' when in production to ensure the SSL is enabled.
    }
    else
    {
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, TRUE); //This should always be set to 'TRUE' when in production to ensure the SSL is enabled.
    }
    $response = curl_exec ($ch);     
    curl_close ($ch);
    
    ob_end_clean();
    
    //echo $xml." ".$response;
    
    $xml = new SimpleXMLElement($response);
    //print_r($xml);
    //exit;
    
    $result=$xml->result;
    $message=$xml->message;
    $orderid=$xml->orderid;
    $md5hash=$xml->md5hash;
    $pasref=$xml->pasref;
    $authcode=$xml->authcode;
    $timestamp=$this->xml_attribute($xml,'timestamp');
    
    
    ?>
    <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
    <html>
      <head>
      <title><?php echo JText::_( 'PMB_REALEX_MODULE_PROCESSING' );?></title>
      </head>
      <body>
      <div style="width:100%;text-align:center;">
        <strong><?php echo JText::_( 'PMB_REALEX_MODULE_PROCESSING' );?></strong>
      </div>
      
      <form name="returnFrm" method="post" action="<?php echo JROUTE::_(JURI::root()."modules/mod_paymybill/return/realex_return.php")?>">
        <input type="hidden" name="result" value="<?php echo $result;?>" />
        <input type="hidden" name="message" value="<?php echo str_replace('"',"&quot;",$message);?>" />
        <input type="hidden" name="orderid" value="<?php echo $orderid;?>" />
        <input type="hidden" name="md5hash" value="<?php echo $md5hash;?>" />
        <input type="hidden" name="timestamp" value="<?php echo $timestamp;?>" />
        <input type="hidden" name="pasref" value="<?php echo $pasref;?>" />
        <input type="hidden" name="authcode" value="<?php echo $authcode;?>" />
      </form>
      <script type="text/javascript">
        setTimeout(function(){document.returnFrm.submit();},3000);
      </script>
      </body>
    </html>
    <?php
    exit;
  }
  function xml_attribute($object, $attribute)
  {
      if(isset($object[$attribute]))
          return (string) $object[$attribute];
  }
}
?>